#pragma once

#include "ofMain.h"
#include "ofxOpenCv.h"
#include "ofxKinect.h"
#include "ofxCvHaarFinder.h"


class ofApp : public ofBaseApp{
public:
    void setup();
    void update();
    void draw();
    
    ofxCvGrayscaleImage setPixelsSubRegion(ofxCvGrayscaleImage  orgImage, int x, int y,int width, int height);
    
    void keyPressed(int key);
    void keyReleased(int key);
    void mouseMoved(int x, int y);
    void mouseDragged(int x, int y, int button);
    void mousePressed(int x, int y, int button);
    void mouseReleased(int x, int y, int button);
    void windowResized(int w, int h);
    void dragEvent(ofDragInfo dragInfo);
    void gotMessage(ofMessage msg);
    
    void exit();
    
    ofxCvHaarFinder         faceFinder;
    ofxCvContourFinder		contourFinder;
    ofxKinect               kinect;
    
    ofxCvGrayscaleImage     depthImg; // grayscale depth image
    ofxCvGrayscaleImage     grayThreshNear; // the near thresholded image
    ofxCvGrayscaleImage     grayThreshFar; // the far thresholded image
    ofxCvGrayscaleImage		grayscaleImage;
    ofxCvColorImage         colorImg;
    ofxCvGrayscaleImage     blobImg;
    
    vector<ofxCvGrayscaleImage> blobArray;
    vector<ofxCvGrayscaleImage> blobImgArray;
    vector<ofRectangle>         blobFaceArray;
    vector<int>                 blobNrFaces;
    int                         nrBlobs;

    ofRectangle faceRectangle;
    int width;
    int height;
    int x;
    int y;

    int nearThreshold;
    int farThreshold;
    int angle;
    
    int threshold;
    int minBlobSize;
    int maxBlobSize;
    int nBlobsConsidered;

    //Blob stuff
    
    
    bool bLearnBg;
    
};
